#ifndef _incl_defns
#define _incl_defns

typedef void (*Combine_func)(float **, float *);

typedef struct
{
    int ndim;
    int *block_size_in;
    int *block_size_out;
    int *npoints_in;
    int *npoints_out;
}   Size_info;

typedef struct
{
    float **row_in;
    float *row_out;
    float **store_in;
    float *store_out;
}   Store_info;

typedef struct
{
    int ninput_files;
    Line *input_file;
    String output_file;
    FILE **file_in;
    FILE *file_out;
    Bool swapped;
    Bool integer;
    Bool blocked;
    int header;
}   File_info;

typedef struct
{
    int dim;
    int type;
    Combine_func combine_func;
}   Combine_info;

#endif /* _incl_defns */
