#ifndef _incl_crosspeak
#define _incl_crosspeak

#include "macros.h"
#include "types.h"
#include "consts.h"
#include "defns.h"

#include "atom.h"

/* this was done when thought all crosspeak files had dim 4
#define  CROSSPEAK_DIM		4
*/

typedef struct
{
    float intensity;
    float distance;
    float distance_minus;
    float distance_plus;
    int number;
    float intensity_unscaled;
    String spectrum;
}   Crosspeak_data;

typedef struct
{
    Atom *atom;
    Crosspeak_data data;
}   Crosspeak;

extern Status read_crosspeak_file
	(FILE *fp, Connect_info *info, int *p_ncrosspeaks,
		Crosspeak ***p_crosspeaks, String error_msg);

#endif /* _incl_crosspeak */
