#ifndef _incl_contoured
#define _incl_contoured

#include "macros.h"
#include "types.h"

#define  POSITIVE_CONTOUR	(1 << 0)
#define  NEGATIVE_CONTOUR	(1 << 1)
#define  BOTH_CONTOURS		(POSITIVE_CONTOUR | NEGATIVE_CONTOUR)

typedef struct
{
    float version;	/* version number */
    int ndim;		/* number of dimensions */
    int *dim;		/* first 2 are contour dimensions, remaining follow */
    int *dim_map;	/* the order Ansig sees dim */
    float *lower;	/* lower ppm value of contours */
    float *upper;	/* upper ppm value of contours */
    float ppm0;		/* ppm size of first contour dimension */
    float ppm1;		/* ppm size of second contour dimension */
    int *pnts;		/* number of subplanes in contour dimensions,
			   number of points contoured in other dimensions */
}   Header_info;

typedef Status (*Contour_polyline_func)(int pos_neg, int n,
					float *x, float *y, String error_msg);

extern Status read_contours_header
	(String file, Header_info *info, String error_msg);

extern Status read_contours_data
	(String file, Header_info *info, int block_size,
			int pos_neg, float *lower, float *upper,
			Contour_polyline_func func, String error_msg);

#endif /* _incl_contoured */
