#ifndef _incl_nonlinear_model
#define _incl_nonlinear_model

#include "macros.h"
#include "types.h"

#define  INITIAL_STAGE		1
#define  GENERAL_STAGE		2
#define  FINAL_STAGE		3

typedef void (*Nonlinear_model_func)(float x, float *a, float *y, float *dy_da);

extern void nonlinear_model
	(float *x, float *y, float *w, int n,
			float *a, float **covar, float **alpha,
			float *beta, float *da, float *ap, float *dy_da,
			int *piv, int *row, int *col, int m,
			float *chisq, float *lambda,
			Nonlinear_model_func func, int stage, Bool *singular);


#endif /* _incl_nonlinear_model */
