#ifndef _incl_poly_roots
#define _incl_poly_roots

#include "macros.h"
#include "types.h"

#include "complex.h"

/*
    a gives complex coefficients of nth order polynomial
    so a is complex array of size (n+1)
    polynomial = a[n] z^n + ... + a[0]
    roots is complex array of size n
    w is working complex array of size (at least) (n+1)
    returns TRUE if converged, FALSE if not
*/
extern Bool poly_roots
        (Complex *a, int n, Complex *roots, Bool polish, Complex *w);

#endif /* _incl_poly_roots */
