#ifndef _incl_widget
#define _incl_widget

#include <stdio.h>
#include <math.h>

#include <X11/cursorfont.h>
#include <X11/keysym.h>

#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/DialogS.h>
#include <Xm/DrawingA.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/Protocols.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleBG.h>

#ifdef USE_XPM
#include <X11/xpm.h>
#endif /* USE_XPM */

#define  ARRAY_SIZE(x)		XtNumber(x)

#define  WIDGET_PARENT(x)	XtParent(x)
#define  WIDGET_DISPLAY(x)	XtDisplay(x)
#define  WIDGET_WINDOW(x)	XtWindow(x)
#define  WIDGET_SCREEN(x)	XtScreen(x)

#define  DISPLAY_SCREEN(x)	DefaultScreenOfDisplay(x)
#define  DISPLAY_DEPTH(x)	DefaultDepthOfScreen(DefaultScreenOfDisplay(x))

#define  HORIZONTAL		XmHORIZONTAL
#define  VERTICAL		XmVERTICAL

#define  MULTI_LINE_EDIT	XmMULTI_LINE_EDIT

#define  SINGLE_SELECT		XmSINGLE_SELECT
#define  BROWSE_SELECT		XmBROWSE_SELECT
#define  MULTIPLE_SELECT	XmMULTIPLE_SELECT
#define  EXTENDED_SELECT	XmEXTENDED_SELECT

#define  BUTTON_PRESS_MASK	ButtonPressMask
#define  BUTTON_RELEASE_MASK	ButtonReleaseMask
#define  POINTER_MOTION_MASK	PointerMotionMask
#define  ENTER_WINDOW_MASK	EnterWindowMask
#define  LEAVE_WINDOW_MASK	LeaveWindowMask
#define  KEY_PRESS_MASK		KeyPressMask
#define  KEY_RELEASE_MASK	KeyReleaseMask

#define  BACKSPACE_KEY		XK_BackSpace
#define  DELETE_KEY		XK_Delete
#define  UP_KEY			XK_Up
#define  DOWN_KEY		XK_Down
#define  LEFT_KEY		XK_Left
#define  RIGHT_KEY		XK_Right
#define  LEFT_SHIFT_KEY		XK_Shift_L
#define  RIGHT_SHIFT_KEY	XK_Shift_R

typedef XtPointer Callback_ptr;
typedef XtCallbackProc Callback_proc;
typedef EventMask Event_mask;
typedef KeySym Key_symbol;
typedef unsigned int Button;

#include "macros.h"
#include "types.h"

#endif /* _incl_widget */
