#include "date.h"

/*  not sure need all of below, but play safe  */
#include <sys/types.h>
#ifndef WIN32
#include <sys/time.h>
#endif /* WIN32 */
#include <time.h>

typedef char Month_string[4];
static Month_string month_strings[] =
{ "Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

void get_time_and_date(String time_and_date)
{
    int day, month, year, sec, min, hour;
    time_t t;
    struct tm *ts;

    t = time((time_t *) NULL);
    ts = localtime(&t);

    day = ts->tm_mday;
    month = ts->tm_mon;
    year = ts->tm_year + 1900;
	/* days start at 1, months start at 0, 1900 is year 0 */
    hour = ts->tm_hour;
    min = ts->tm_min;
    sec = ts->tm_sec;

    sprintf(time_and_date, "%02d:%02d:%02d, %d %s %d",
			hour, min, sec, day, month_strings[month], year);
}

#ifdef TEST

void main()
{
    Line line;

    get_time_and_date(line);

    printf("time and date: %s\n", line);
}

#endif /* TEST */
