#ifndef _incl_line_fit
#define _incl_line_fit

#include "macros.h"
#include "types.h"

/* input n, x and y, and optionally sigma, and output rest */
/* sigma should be NULL if it is not used */
/* goodness of fit is only properly calculated if sigma is known */
/*   otherwise it is sum of squares of differences between y and yfit */
/* on output yfit = a + b*x */

extern void line_fit
	(int n, float *x, float *y, float *sigma, float *yfit,
		float *a, float *b, float *std_a, float *std_b,
		float *corr_ab, float *goodness);

#endif /* _incl_line_fit */
