#ifndef _incl_param_param
#define _incl_param_param

static Parameter parameters[] =
{
/* baseline_popup */
    { baseline_file,	"baseline.baseline_file" },
    { half_width,	"baseline.half_width" },
    { degree_order,	"baseline.degree_order" },
    { baseline_used,	"baseline.baseline_used" },
    { base_fit_used,	"baseline.base_fit_used" },
/* display_popup */
    { display_width,	"display.display_width" },
    { display_height,	"display.display_height" },
    { background_color,	"display.background_color" },
/* extract_popup */
    { param_file,	"extract.parameter_file" },
    { data_scale,	"extract.data_scale" },
    { plane_name,	"extract.plane_name" },
    { plane_dirns,	"extract.plane_directions" },
    { plane_subset,	"extract.plane_subset" },
    { plane_thick,	"extract.plane_thickness" },
    { plane_point,	"extract.point_on_plane" },
    { plane_ref,	"extract.reference" },
    { first_points,	"extract.first_points" },
    { last_points,	"extract.last_points" },
    { step_points,	"extract.steps_through_points" },
    { script_file,	"extract.script_file" },
/* fit_popup */
    { fit_width,	"fit.display_width" },
    { fit_height,	"fit.display_height" },
    { fit_method,	"fit.fit_method" },
/* fold_popup */
    { x_fold,		"fold.x_fold" },
    { y_fold,		"fold.y_fold" },
    { x_flip,		"fold.x_flip" },
    { y_flip,		"fold.y_flip" },
    { x_width_min,	"fold.x_width_min" },
    { x_width_max,	"fold.x_width_max" },
    { x_width_value,	"fold.x_width_value" },
    { x_center_min,	"fold.x_center_min" },
    { x_center_max,	"fold.x_center_max" },
    { x_center_value,	"fold.x_center_value" },
    { y_width_min,	"fold.y_width_min" },
    { y_width_max,	"fold.y_width_max" },
    { y_width_value,	"fold.y_width_value" },
    { y_center_min,	"fold.y_center_min" },
    { y_center_max,	"fold.y_center_max" },
    { y_center_value,	"fold.y_center_value" },
/* levels_popup */
    { base_level,	"levels.base_level" },
    { number_levels,	"levels.number_of_levels" },
    { change_levels,	"levels.change_between_levels" },
    { change_mode,	"levels.change_mode" },
    { level_modifier,	"levels.level_modifier" },
    { timer_mode,	"levels.timer_mode" },
/* object_popup */
    { pos_visible,	"object.positive_visible" },
    { neg_visible,	"object.negative_visible" },
    { col_visible,	"object.columns_visible" },
    { row_visible,	"object.rows_visible" },
    { cross_visible,	"object.crosshair_visible" },
    { grid_visible,	"object.grid_visible" },
    { ruler_visible,	"object.ruler_visible" },
    { pos_color,	"object.positive_color" },
    { neg_color,	"object.negative_color" },
    { col_color,	"object.column_color" },
    { row_color,	"object.row_color" },
    { cross_color,	"object.crosshair_color" },
    { grid_color,	"object.grid_color" },
    { ruler_color,	"object.ruler_color" },
    { default_color,	"object.object_color" },
    { default_visible,	"object.object_visible" },
    { major_ticks,	"object.major_ticks" },
    { minor_ticks,	"object.minor_ticks" },
/* output_popup */
    { output_file,	"output.output_file" },
    { output_title,	"output.output_title" },
    { output_size,	"output.output_size" },
    { size_mode,	"output.size_mode" },
    { size_units,	"output.size_units" },
    { display_mode,	"output.display_mode" },
    { time_date,	"output.time_date" },
    { show_name,	"output.show_name" },
    { tick_place,	"output.tick_place" },
    { tick_show,	"output.tick_show" },
    { paper_size,	"output.paper_size" },
    { other_size,	"output.other_size" },
    { paper_dirn,	"output.paper_dirn" },
    { output_color,	"output.output_color" },
    { output_gl,	"output.output_gl" },
/* peaks_popup */
    { peaks_file,	"peaks.peaks_file" },
/* phase_popup */
    { phase_on_off,	"phase.phase_on_off" },
    { phase_pivot,	"phase.phase_pivot" },
    { phase0_min,	"phase.phase0_min" },
    { phase0_max,	"phase.phase0_max" },
    { phase0_value,	"phase.phase0_value" },
    { phase1_min,	"phase.phase1_min" },
    { phase1_max,	"phase.phase1_max" },
    { phase1_value,	"phase.phase1_value" },
/* prop_popup */
    { object_color,	"property.object_color" },
    { object_scale,	"property.object_scale" },
    { object_visible,	"property.object_visible" },
/* region_popup */
    { x_region,		"region.x_region" },
    { y_region,		"region.y_region" },
    { region_ref,	"region.reference" },
    { position_name,	"region.position_name" },
    { stats_use_file,	"region.stats_use_file" },
    { statistics_file,	"region.statistics_file" },
/* rowcol_popup */
    { point_range,	"rowcol.point_range" },
    { rowcol_ref,	"rowcol.reference" },
    { point_ruler,	"rowcol.point_ruler" },
    { point_axis,	"rowcol.point_axis" },
    { value_range,	"rowcol.value_range" },
    { value_ruler,	"rowcol.value_ruler" },
    { value_axis,	"rowcol.value_axis" },
    { row_col,		"rowcol.row_col" },
    { new_add,		"rowcol.new_add" },
    { rows_cols,	"rowcol.rows_cols" },
/* save_popup */
    { save_data,	"save.data_file" },
    { save_param,	"save.parameter_file" },
    { save_region,	"save.region_type" },
/* slice_popup */
    { slice_width,	"slice.display_width" },
    { slice_height,	"slice.display_height" },
/* tracking_popup */
    { tracking_width,	"tracking.display_width" },
    { tracking_height,	"tracking.display_height" },
/* */
    { NULL,		NO_PATTERN }
};

#endif /* _incl_param_param */
