#include "reduce.h"

#include "command.h"

static int ncodes = 0;
static int npoints[MAX_NCODES];

static void do_reduce(int code, float *data)
{
    int i;

    for (i = 0; i < npoints[code]; i++)
	data[i] = data[2*i];
}

Status init_reduce(Generic_ptr *param, String error_msg)
{
    int type, npts;

    if (setup_command(&type, &npts, ncodes, "reduce",
					do_reduce, error_msg) == ERROR)
        return  ERROR;

    if (type != COMPLEX_DATA)
	RETURN_ERROR_MSG("'reduce': must have complex data");

    type = REAL_DATA;
    npts /= 2;

    npoints[ncodes] = npts;

    CHECK_STATUS(end_command(type, npts, "reduce", error_msg));

    ncodes++;

    return  OK;
}
